﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
            comboBox.SelectedIndex = 0;
            pictureBox_SizeChanged (null, null);
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            int w = pictureBox.Width;
            int h = pictureBox.Height;
            if (w > 0 && h > 0)
            {
                Image last = pictureBox.Image;
                if (last != null)
                {
                    w = Math.Max(w, last.Width);
                    h = Math.Max(h, last.Height);
                }
                pictureBox.Image = new Bitmap (w, h);
                Graphics g = Graphics.FromImage(pictureBox.Image);
                Brush b = new SolidBrush(Color.White);
                g.FillRectangle(b, 0, 0, w - 1, h - 1);
                if (last != null)
                    g.DrawImage(last, 0, 0);
            }
        }

        private int X0, Y0;
        private bool pressed = false;
        private Bitmap save;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            pressed = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (pressed)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen p = new Pen(Color.Red, 3);
                int inx = comboBox.SelectedIndex;
                switch (inx)
                {
                    case 0:
                        g.DrawLine(p, X0, Y0, e.X, e.Y);
                        break;

                    case 1:
                        g.DrawRectangle(p, X0, Y0, e.X - X0, e.Y - Y0);
                        break;

                    case 2:
                        g.DrawEllipse(p, X0, Y0, e.X - X0, e.Y - Y0);
                        break;
                }
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            pressed = false;
            // Brush b = new SolidBrush(Color.Blue);
            // g.FillRectangle(b, e.X - 1, e.Y - 1, 3, 3);
        }


    }
}
